VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "                           VBClassic = Yes              VB.NET = No"
   ClientHeight    =   3945
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7365
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3945
   ScaleWidth      =   7365
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command1 
      Caption         =   "Open File and Fill Listboxes"
      Default         =   -1  'True
      Height          =   315
      Left            =   2850
      TabIndex        =   1
      Top             =   3420
      Width           =   2235
   End
   Begin VB.ListBox lbo 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2700
      Index           =   0
      Left            =   240
      TabIndex        =   0
      Top             =   420
      Width           =   1485
   End
   Begin VB.Label lblHeader 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H00C0C0C0&
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H80000008&
      Height          =   225
      Index           =   0
      Left            =   270
      TabIndex        =   2
      Top             =   180
      Width           =   1455
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' VBClassic rules over VB.NOT (Sorry VB.NET)
' Rob Crombie
' rob@crombie.com
'
' OO arose as an attempt to solve the problems of messy programming.
' However OO adds complications of it's own.
' Then VB.NET arose out of the demands by hard core programmers to get pure OO
' I will be preparing an essay soon, that explains how to use classic VB
'  to solve those original problesm (without resorting to OO).
' Thus you can be spared the upcoming problems in VB.NET -
' - OO complexities (Having to think in 'OO', plus managing all those objects)
' - Security
' - Deployment
' - Versioning
' - etc
'
' Hint for upcoming essay (improving classic vb)
' - Encapuslation
' - Code re-use
'
' The code below was created in response to a request in an email group.
' It was not created as an example for the above,
'                however
' I have attempted to demonstrate encapsulation and code re-use


Option Explicit

Private Sub Command1_Click()
 Dim FilePathAndName As String
 Dim sAll As String 'Place all of file's contents into here
 Dim arrAll() As String 'Split contents into an element for each listbox
 Dim sSet As String     'Place one set of data into this EG all ANIMALS
 Dim i As Integer
  FilePathAndName = App.Path & "\" & "myFile.txt"
  sAll = GetFileContents(FilePathAndName)
  'Remove first char (removing the first "[" means Split will do what I want)
  sAll = Mid(sAll, 2)
  arrAll = Split(sAll, "[")
  'Create extra listboxes and Headers
  If UBound(arrAll) > 0 Then
    CreateAdditionalListboxesAndHeaders lbo, lblHeader, UBound(arrAll)
  End If
  'Load data into listboxes
  i = 0
  For i = 0 To UBound(arrAll)
    'Get a set of data
    sSet = arrAll(i)
    LoadDataIntoListbox lbo, lblHeader, i, sSet
  Next i 'increment i so as to get data for next listbox
  
  Command1.Enabled = False
End Sub


'Get File's contents, and place into string
Private Function GetFileContents(ByVal file_name As String) As String
 Dim fnum As Integer
    fnum = FreeFile
    Open file_name For Input As fnum
    GetFileContents = Input(LOF(fnum), fnum)
    Close fnum
End Function

Private Sub CreateAdditionalListboxesAndHeaders(LBOX, LBL, DesiredUBound As Integer)
 Dim i As Integer
  i = 1 'NB initial lbo had index of 0, so 2nd lbo index will = 1
  Do Until i > DesiredUBound
    'Create new listbox
    Load LBOX(i)
    'Position Listbox
    LBOX(i).Top = LBOX(0).Top
    LBOX(i).Left = LBOX(i - 1).Left + LBOX(i - 1).Width + 300
    LBOX(i).Visible = True
    'Create new Header
    Load LBL(i)
    'Position Header
    LBL(i).Top = LBL(0).Top
    LBL(i).Left = LBOX(i).Left
    LBL(i).Visible = True
    i = i + 1
  Loop
End Sub

Private Sub LoadDataIntoListbox(LBOX, LBL, Index As Integer, strIN As String)
 Dim arrSet() As String 'Break string into it's elements EG dog cat
 Dim myStr As String
 Dim j As Integer
  'Split that set into its bits EG ANIMALS] dog cat
  arrSet = Split(strIN, vbCrLf)
  'Take first element and place into lblHeader
  myStr = arrSet(0)
  LBL(Index).Caption = Left(myStr, Len(myStr) - 1) 'Removed ']'
  'Place the other elements into listbox
  For j = 1 To UBound(arrSet)
    myStr = arrSet(j)
    If myStr > "" Then
      LBOX(Index).AddItem myStr
    End If
  Next j 'increment j so as to get next dog or cat etc
End Sub
